F. Pudding Monsters
time limit per test

2 seconds

memory limit per test

256 megabytes

In this problem you will meet the simplified model of game Pudding Monsters.

An important process in developing any game is creating levels. A game field in Pudding Monsters is an n × n rectangular grid, n of its cells contain monsters and some other cells contain game objects. The gameplay is about moving the monsters around the field. When two monsters are touching each other, they glue together into a single big one (as they are from pudding, remember?).

Statistics showed that the most interesting maps appear if initially each row and each column contains exactly one monster and the rest of map specifics is set up by the correct positioning of the other game objects.

A technique that's widely used to make the development process more efficient is reusing the available resources. For example, if there is a large n × n map, you can choose in it a smaller k × k square part, containing exactly k monsters and suggest it as a simplified version of the original map.

You wonder how many ways there are to choose in the initial map a k × k (1 ≤ k ≤ n) square fragment, containing exactly k pudding monsters. Calculate this number.

Input

The first line contains a single integer n (1 ≤ n ≤ 3 × 105) — the size of the initial field.

Next n lines contain the coordinates of the cells initially containing monsters. The i-th of the next lines contains two numbers ri, ci(1 ≤ ri, ci ≤ n) — the row number and the column number of the cell that initially contains the i-th monster.

It is guaranteed that all ri are distinct numbers and all ci are distinct numbers.

Output

Print the number of distinct square fragments of the original field that can form a new map.

Examples
input
5
1 1
4 3
3 2
2 4
5
output
10

题解:

考试的时候这道题真是吓到我了。。一开始以为是一道单纯的数数题,后来发现并不简单。。。

我们把这个棋盘模型抽象一下,这个棋盘由于

Statistics showed that the most interesting maps appear if initially each row and each column contains exactly one monster and the rest of map specifics is set up by the correct positioning of the other game objects.

也就是说,一行一列只有1个怪物,所以我们可以把它抽象为(化简为)一个1~n的排列

如果定义max(l,r)为区间[l,r]的最大值,min(l,r)为区间[l,r]的最小值,

我们需要的目标正方形,就对应这个排列中的某一个区间[l,r],并且满足max(l,r)-min(l,r)==r-l

接下来是关键的一步:我们考虑分治统计这些合法区间(似乎有一些类似cdq?)。

也就是说,如果设f(l,r)为区间[l,r]的合法区间数量,mi=(l+r)>>1

那么f(l,r)=f(l,mi)+f(mi+1,r)+『跨中点的合法解数量』

接下来我们考虑如何统计跨中点的合法解数量。

对于跨中点的合法解,其可能情况有4种:

1°max(l,r),min(l,r)均在左侧

2°max(l,r),min(l,r)均在右侧

3°max(l,r)在左侧,min(l,r)在右侧

4°max(l,r)在右侧,min(l,r)在左侧

简单来说,就是极值“在同侧”和“在异侧”两种情况

如果极值在同侧,我们可以枚举一个端点,并且计算出区间长度,从而得到另外一个端点,

最后判断是否合法,也即判断另外一侧是否有更大/小的极值

如果极值在异侧,我们依旧枚举其中一个端点,

(我们这里仅讨论最小值在左侧的情况,最小值在右侧的情况是与此对称的)

然后我们考虑上面的式子max(mi+1,r)-min(l,mi)==r-l

移项可得max(mi+1,r)-r==min(l,mi)-l

这样我们就可以枚举左端点,再用桶维护每个min(l,mi)-l对应的合法解个数(通过扫描右区间可得)

但要注意,min(l,mi)-l可能是负值,因此我们要给他加上一个较大值(比如N)

最后统计答案即可。代码见下:

 #include <cstdio>
#include <cstring>
using namespace std;
typedef long long LL;
const int N=;
int n,A[N],cnt[N*+],maxl[N],minl[N],maxr[N],minr[N];
inline int max(int a,int b){return a>b?a:b;}
inline int min(int a,int b){return a<b?a:b;}
LL divide(int l,int r)
{
if(l==r)return ;
register int mi=(l+r)>>,i,j,k;
LL ret=divide(l,mi)+divide(mi+,r);
maxl[mi]=minl[mi]=A[mi],maxr[mi+]=minr[mi+]=A[mi+];
for(i=mi-;i>=l;--i)maxl[i]=max(maxl[i+],A[i]),minl[i]=min(minl[i+],A[i]);
for(i=mi+;i<=r;++i)maxr[i]=max(maxr[i-],A[i]),minr[i]=min(minr[i-],A[i]);
for(i=l;i<=mi;++i)
{
j=i+maxl[i]-minl[i];
if(j<=r&&j>mi&&maxr[j]<maxl[i]&&minr[j]>minl[i])ret++;
}
for(i=r;i>mi;--i)
{
j=i-(maxr[i]-minr[i]);
if(j>=l&&j<=mi&&maxl[j]<maxr[i]&&minl[j]>minr[i])ret++;
}
for(i=mi,j=mi+,k=mi;i>=l;--i)
{
while(j<=r&&maxr[j]<maxl[i])--cnt[maxr[j]-j+N],++j;
while(k<r&&minr[k+]>minl[i])++k,++cnt[maxr[k]-k+N];
ret+=max(cnt[minl[i]-i+N],);
}
for(i=mi+;i<=r;++i)cnt[maxr[i]-i+N]=;
for(i=mi,j=mi+,k=mi;i>=l;--i)
{
while(j<=r&&minr[j]>minl[i])--cnt[minr[j]+j],++j;
while(k<r&&maxr[k+]<maxl[i])++k,++cnt[minr[k]+k];
ret+=max(cnt[maxl[i]+i],);
}
for(i=mi+;i<=r;++i)cnt[minr[i]+i]=;
return ret;
}
int main()
{
scanf("%d",&n);int a,b;register int i,j;
for(i=;i<=n;++i)scanf("%d%d",&a,&b),A[a]=b;
printf("%I64d\n",divide(,n));
}

这道题的代码实现不是很难,但是这种模型的转换,以及分治的想法是很excellent的,真是长见识了。

我不经常用分治的方法解题……以后刷题的时候要多想想这方面的解法了。

[Codeforces526F]Pudding Monsters 分治的更多相关文章

  1. CodeForces526F:Pudding Monsters (分治)

    In this problem you will meet the simplified model of game Pudding Monsters. An important process in ...

  2. 【CF526F】Pudding Monsters cdq分治

    [CF526F]Pudding Monsters 题意:给你一个排列$p_i$,问你有对少个区间的值域段是连续的. $n\le 3\times 10^5$ 题解:bzoj3745 Norma 的弱化版 ...

  3. Codeforces 526F Pudding Monsters - CDQ分治 - 桶排序

    In this problem you will meet the simplified model of game Pudding Monsters. An important process in ...

  4. CF526F Pudding Monsters

    CF526F Pudding Monsters 题目大意:给出一个\(n* n\)的棋盘,其中有\(n\)个格子包含棋子. 每行每列恰有一个棋子. 求\(k*k\)的恰好包含\(k\)枚棋子的子矩形个 ...

  5. 「CF526F」 Pudding Monsters

    CF526F Pudding Monsters 传送门 模型转换:对于一个 \(n\times n\) 的棋盘,若每行每列仅有一个棋子,令 \(a_x=y\),则 \(a\) 为一个排列. 转换成排列 ...

  6. Pudding Monsters CodeForces - 526F (分治, 双指针)

    大意: n*n棋盘, n个点有怪兽, 求有多少边长为k的正方形内恰好有k只怪兽, 输出k=1,...,n时的答案和. 等价于给定n排列, 对于任意一个长为$k$的区间, 若最大值最小值的差恰好为k, ...

  7. [Codeforce526F]:Pudding Monsters(分治)

    题目传送门 题目描述 由于各种原因,桐人现在被困在Under World(以下简称UW)中,而UW马上要迎来最终的压力测试——魔界入侵.唯一一个神一般存在的Administrator被消灭了,靠原本的 ...

  8. 奇袭 CodeForces 526F Pudding Monsters 题解

    考场上没有认真审题,没有看到该题目的特殊之处: 保证每一行和每一列都恰有一只军队,即每一个Xi和每一个Yi都是不一样 的. 于是无论如何也想不到复杂度小于$O(n^3)$的算法, 只好打一个二维前缀和 ...

  9. 【CF526F】Pudding Monsters

    题意: 给你一个排列pi,问你有对少个区间的值域段是连续的. n≤3e5 题解: bzoj3745

随机推荐

  1. Node JS World

    Node JS World Environment tested on Ubuntu Install nvm/node/npm/yarn nvm : node version manager node ...

  2. Altium中坐标的导出及利用坐标快速布局

    器件的坐标其实在我们处理布局的时候,非常有用,例如A板布局导入B板. 1.在A板PCB中执行菜单命令“File-Assembly-Generates Pick and Place File”对器件的坐 ...

  3. 我所理解的selenium之PO设计模式

    下午,花了点时间来整理UI自动化设计,就把我所理解的PO设计模式项目结构脑图整理如下,有不对的地方还望多多包涵.谢谢

  4. tpshop购物网站价格筛选功能的测试用例设计

    测试对象:红框内的“价格筛选功能” 以下是功能需求: 1. 除了空以外,输入框不能输入数字之外的内容. 备注:如果出现数字之外的内容,输入框禁止输入. 2. 输入框不能小于0 备注:如果出现小于0的数 ...

  5. cpp-variable-lifetime

    #include <cstdio> #include <iostream> using namespace std; class TmpClass; void FuncScop ...

  6. python3实现合并两个有序数组

    很早就听同学和师兄经常说刷题很重要,然而编程能力一直都很渣的我最近才开始从leetcode的初级算法开始.今天遇到的这道题虽然很简单,因为是头一次用自己的方法速度还不错,特此记录一下,还大神们请不要嘲 ...

  7. 03_set slice的时间复杂度

    set slice O(n+k) 使用切片赋值来解释set slice的时间复杂度 (1) 对li[0:3]赋值首先会删除1,2,3,空出来的位置被后面的元素依次向前移动填充,由del slice 得 ...

  8. Webstorm使用时发生Page 'http://localhost:63340/n…tok/css/bootstrap.css.map' requested without authorization, you can copy URL and open it in browser to trust it.

    在使用webstorm编辑器开发时候,点击4处发生以下错误: Page 'http://localhost:63340/n…tok/css/bootstrap.css.map' requested w ...

  9. php 数组去重

    php 数组去重 数组中重复项的去除 2010-07-28 15:29 一维数组的重复项: 使用array_unique函数即可,使用实例如下: <?php                    ...

  10. “Hello World!“”团队第七周召开的第二次会议

    今天是我们团队“Hello World!”团队第七周召开的第二次会议.博客内容: 一.会议时间 二.会议地点 三.会议成员 四.会议内容 五.todo list 六.会议照片 七.燃尽图 八.代码 一 ...